"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ora;
exports.oraPromise = oraPromise;

var _nodeProcess = _interopRequireDefault(require("process"));

var _chalk = _interopRequireDefault(require("chalk"));

var _cliCursor = _interopRequireDefault(require("cli-cursor"));

var _cliSpinners = _interopRequireDefault(require("cli-spinners"));

var _logSymbols = _interopRequireDefault(require("log-symbols"));

var _stripAnsi = _interopRequireDefault(require("strip-ansi"));

var _wcwidth = _interopRequireDefault(require("wcwidth"));

var _isInteractive = _interopRequireDefault(require("is-interactive"));

var _isUnicodeSupported = _interopRequireDefault(require("is-unicode-supported"));

var _utilities = require("./utilities.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; return (_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; })(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var stdinDiscarder;

var _linesToClear = /*#__PURE__*/new WeakMap();

var _isDiscardingStdin = /*#__PURE__*/new WeakMap();

var _lineCount = /*#__PURE__*/new WeakMap();

var _frameIndex = /*#__PURE__*/new WeakMap();

var _options = /*#__PURE__*/new WeakMap();

var _spinner = /*#__PURE__*/new WeakMap();

var _stream = /*#__PURE__*/new WeakMap();

var _id = /*#__PURE__*/new WeakMap();

var _initialInterval = /*#__PURE__*/new WeakMap();

var _isEnabled = /*#__PURE__*/new WeakMap();

var _isSilent = /*#__PURE__*/new WeakMap();

var _indent = /*#__PURE__*/new WeakMap();

var _text = /*#__PURE__*/new WeakMap();

var _prefixText = /*#__PURE__*/new WeakMap();

var Ora = /*#__PURE__*/function () {
  function Ora(options) {
    _classCallCheck(this, Ora);

    _classPrivateFieldInitSpec(this, _linesToClear, {
      writable: true,
      value: 0
    });

    _classPrivateFieldInitSpec(this, _isDiscardingStdin, {
      writable: true,
      value: false
    });

    _classPrivateFieldInitSpec(this, _lineCount, {
      writable: true,
      value: 0
    });

    _classPrivateFieldInitSpec(this, _frameIndex, {
      writable: true,
      value: 0
    });

    _classPrivateFieldInitSpec(this, _options, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _spinner, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _stream, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _id, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _initialInterval, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _isEnabled, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _isSilent, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _indent, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _text, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _prefixText, {
      writable: true,
      value: void 0
    });

    _defineProperty(this, "color", void 0);

    if (!stdinDiscarder) {
      stdinDiscarder = new _utilities.StdinDiscarder();
    }

    if (typeof options === 'string') {
      options = {
        text: options
      };
    }

    _classPrivateFieldSet(this, _options, _objectSpread({
      color: 'cyan',
      stream: _nodeProcess["default"].stderr,
      discardStdin: true,
      hideCursor: true
    }, options)); // Public


    this.color = _classPrivateFieldGet(this, _options).color; // It's important that these use the public setters.

    this.spinner = _classPrivateFieldGet(this, _options).spinner;

    _classPrivateFieldSet(this, _initialInterval, _classPrivateFieldGet(this, _options).interval);

    _classPrivateFieldSet(this, _stream, _classPrivateFieldGet(this, _options).stream);

    _classPrivateFieldSet(this, _isEnabled, typeof _classPrivateFieldGet(this, _options).isEnabled === 'boolean' ? _classPrivateFieldGet(this, _options).isEnabled : (0, _isInteractive["default"])({
      stream: _classPrivateFieldGet(this, _stream)
    }));

    _classPrivateFieldSet(this, _isSilent, typeof _classPrivateFieldGet(this, _options).isSilent === 'boolean' ? _classPrivateFieldGet(this, _options).isSilent : false); // Set *after* `this.#stream`.
    // It's important that these use the public setters.


    this.text = _classPrivateFieldGet(this, _options).text;
    this.prefixText = _classPrivateFieldGet(this, _options).prefixText;
    this.indent = _classPrivateFieldGet(this, _options).indent;

    if (_nodeProcess["default"].env.NODE_ENV === 'test') {
      this._stream = _classPrivateFieldGet(this, _stream);
      this._isEnabled = _classPrivateFieldGet(this, _isEnabled);
      Object.defineProperty(this, '_linesToClear', {
        get: function get() {
          return _classPrivateFieldGet(this, _linesToClear);
        },
        set: function set(newValue) {
          _classPrivateFieldSet(this, _linesToClear, newValue);
        }
      });
      Object.defineProperty(this, '_frameIndex', {
        get: function get() {
          return _classPrivateFieldGet(this, _frameIndex);
        }
      });
      Object.defineProperty(this, '_lineCount', {
        get: function get() {
          return _classPrivateFieldGet(this, _lineCount);
        }
      });
    }
  }

  _createClass(Ora, [{
    key: "indent",
    get: function get() {
      return _classPrivateFieldGet(this, _indent);
    },
    set: function set(indent) {
      if (indent === void 0) {
        indent = 0;
      }

      if (!(indent >= 0 && Number.isInteger(indent))) {
        throw new Error('The `indent` option must be an integer from 0 and up');
      }

      _classPrivateFieldSet(this, _indent, indent);

      this.updateLineCount();
    }
  }, {
    key: "interval",
    get: function get() {
      return _classPrivateFieldGet(this, _initialInterval) || _classPrivateFieldGet(this, _spinner).interval || 100;
    }
  }, {
    key: "spinner",
    get: function get() {
      return _classPrivateFieldGet(this, _spinner);
    },
    set: function set(spinner) {
      _classPrivateFieldSet(this, _frameIndex, 0);

      _classPrivateFieldSet(this, _initialInterval, undefined);

      if (_typeof(spinner) === 'object') {
        if (spinner.frames === undefined) {
          throw new Error('The given spinner must have a `frames` property');
        }

        _classPrivateFieldSet(this, _spinner, spinner);
      } else if (!(0, _isUnicodeSupported["default"])()) {
        _classPrivateFieldSet(this, _spinner, _cliSpinners["default"].line);
      } else if (spinner === undefined) {
        // Set default spinner
        _classPrivateFieldSet(this, _spinner, _cliSpinners["default"].dots);
      } else if (spinner !== 'default' && _cliSpinners["default"][spinner]) {
        _classPrivateFieldSet(this, _spinner, _cliSpinners["default"][spinner]);
      } else {
        throw new Error("There is no built-in spinner named '".concat(spinner, "'. See https://github.com/sindresorhus/cli-spinners/blob/main/spinners.json for a full list."));
      }
    }
  }, {
    key: "text",
    get: function get() {
      return _classPrivateFieldGet(this, _text);
    },
    set: function set(value) {
      _classPrivateFieldSet(this, _text, value || '');

      this.updateLineCount();
    }
  }, {
    key: "prefixText",
    get: function get() {
      return _classPrivateFieldGet(this, _prefixText);
    },
    set: function set(value) {
      _classPrivateFieldSet(this, _prefixText, value || '');

      this.updateLineCount();
    }
  }, {
    key: "isSpinning",
    get: function get() {
      return _classPrivateFieldGet(this, _id) !== undefined;
    } // TODO: Use private methods when targeting Node.js 14.

  }, {
    key: "getFullPrefixText",
    value: function getFullPrefixText() {
      var prefixText = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _classPrivateFieldGet(this, _prefixText);
      var postfix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ' ';

      if (typeof prefixText === 'string' && prefixText !== '') {
        return prefixText + postfix;
      }

      if (typeof prefixText === 'function') {
        return prefixText() + postfix;
      }

      return '';
    }
  }, {
    key: "updateLineCount",
    value: function updateLineCount() {
      var columns = _classPrivateFieldGet(this, _stream).columns || 80;
      var fullPrefixText = this.getFullPrefixText(_classPrivateFieldGet(this, _prefixText), '-');

      _classPrivateFieldSet(this, _lineCount, 0);

      var _iterator = _createForOfIteratorHelper((0, _stripAnsi["default"])(' '.repeat(_classPrivateFieldGet(this, _indent)) + fullPrefixText + '--' + _classPrivateFieldGet(this, _text)).split('\n')),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var line = _step.value;

          _classPrivateFieldSet(this, _lineCount, _classPrivateFieldGet(this, _lineCount) + Math.max(1, Math.ceil((0, _wcwidth["default"])(line) / columns)));
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "isEnabled",
    get: function get() {
      return _classPrivateFieldGet(this, _isEnabled) && !_classPrivateFieldGet(this, _isSilent);
    },
    set: function set(value) {
      if (typeof value !== 'boolean') {
        throw new TypeError('The `isEnabled` option must be a boolean');
      }

      _classPrivateFieldSet(this, _isEnabled, value);
    }
  }, {
    key: "isSilent",
    get: function get() {
      return _classPrivateFieldGet(this, _isSilent);
    },
    set: function set(value) {
      if (typeof value !== 'boolean') {
        throw new TypeError('The `isSilent` option must be a boolean');
      }

      _classPrivateFieldSet(this, _isSilent, value);
    }
  }, {
    key: "frame",
    value: function frame() {
      var _this$frameIndex;

      var _classPrivateFieldGet2 = _classPrivateFieldGet(this, _spinner),
          frames = _classPrivateFieldGet2.frames;

      var frame = frames[_classPrivateFieldGet(this, _frameIndex)];

      if (this.color) {
        frame = _chalk["default"][this.color](frame);
      }

      _classPrivateFieldSet(this, _frameIndex, _classPrivateFieldSet(this, _frameIndex, (_this$frameIndex = _classPrivateFieldGet(this, _frameIndex), ++_this$frameIndex)) % frames.length);

      var fullPrefixText = typeof _classPrivateFieldGet(this, _prefixText) === 'string' && _classPrivateFieldGet(this, _prefixText) !== '' ? _classPrivateFieldGet(this, _prefixText) + ' ' : '';
      var fullText = typeof this.text === 'string' ? ' ' + this.text : '';
      return fullPrefixText + frame + fullText;
    }
  }, {
    key: "clear",
    value: function clear() {
      if (!_classPrivateFieldGet(this, _isEnabled) || !_classPrivateFieldGet(this, _stream).isTTY) {
        return this;
      }

      _classPrivateFieldGet(this, _stream).cursorTo(0);

      for (var index = 0; index < _classPrivateFieldGet(this, _linesToClear); index++) {
        if (index > 0) {
          _classPrivateFieldGet(this, _stream).moveCursor(0, -1);
        }

        _classPrivateFieldGet(this, _stream).clearLine(1);
      }

      if (_classPrivateFieldGet(this, _indent) || this.lastIndent !== _classPrivateFieldGet(this, _indent)) {
        _classPrivateFieldGet(this, _stream).cursorTo(_classPrivateFieldGet(this, _indent));
      }

      this.lastIndent = _classPrivateFieldGet(this, _indent);

      _classPrivateFieldSet(this, _linesToClear, 0);

      return this;
    }
  }, {
    key: "render",
    value: function render() {
      if (_classPrivateFieldGet(this, _isSilent)) {
        return this;
      }

      this.clear();

      _classPrivateFieldGet(this, _stream).write(this.frame());

      _classPrivateFieldSet(this, _linesToClear, _classPrivateFieldGet(this, _lineCount));

      return this;
    }
  }, {
    key: "start",
    value: function start(text) {
      if (text) {
        this.text = text;
      }

      if (_classPrivateFieldGet(this, _isSilent)) {
        return this;
      }

      if (!_classPrivateFieldGet(this, _isEnabled)) {
        if (this.text) {
          _classPrivateFieldGet(this, _stream).write("- ".concat(this.text, "\n"));
        }

        return this;
      }

      if (this.isSpinning) {
        return this;
      }

      if (_classPrivateFieldGet(this, _options).hideCursor) {
        _cliCursor["default"].hide(_classPrivateFieldGet(this, _stream));
      }

      if (_classPrivateFieldGet(this, _options).discardStdin && _nodeProcess["default"].stdin.isTTY) {
        _classPrivateFieldSet(this, _isDiscardingStdin, true);

        stdinDiscarder.start();
      }

      this.render();

      _classPrivateFieldSet(this, _id, setInterval(this.render.bind(this), this.interval));

      return this;
    }
  }, {
    key: "stop",
    value: function stop() {
      if (!_classPrivateFieldGet(this, _isEnabled)) {
        return this;
      }

      clearInterval(_classPrivateFieldGet(this, _id));

      _classPrivateFieldSet(this, _id, undefined);

      _classPrivateFieldSet(this, _frameIndex, 0);

      this.clear();

      if (_classPrivateFieldGet(this, _options).hideCursor) {
        _cliCursor["default"].show(_classPrivateFieldGet(this, _stream));
      }

      if (_classPrivateFieldGet(this, _options).discardStdin && _nodeProcess["default"].stdin.isTTY && _classPrivateFieldGet(this, _isDiscardingStdin)) {
        stdinDiscarder.stop();

        _classPrivateFieldSet(this, _isDiscardingStdin, false);
      }

      return this;
    }
  }, {
    key: "succeed",
    value: function succeed(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].success,
        text: text
      });
    }
  }, {
    key: "fail",
    value: function fail(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].error,
        text: text
      });
    }
  }, {
    key: "warn",
    value: function warn(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].warning,
        text: text
      });
    }
  }, {
    key: "info",
    value: function info(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].info,
        text: text
      });
    }
  }, {
    key: "stopAndPersist",
    value: function stopAndPersist() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (_classPrivateFieldGet(this, _isSilent)) {
        return this;
      }

      var prefixText = options.prefixText || _classPrivateFieldGet(this, _prefixText);

      var text = options.text || this.text;
      var fullText = typeof text === 'string' ? ' ' + text : '';
      this.stop();

      _classPrivateFieldGet(this, _stream).write("".concat(this.getFullPrefixText(prefixText, ' ')).concat(options.symbol || ' ').concat(fullText, "\n"));

      return this;
    }
  }]);

  return Ora;
}();

function ora(options) {
  return new Ora(options);
}

function oraPromise(_x, _x2) {
  return _oraPromise.apply(this, arguments);
}

function _oraPromise() {
  _oraPromise = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(action, options) {
    var actionIsFunction, actionIsPromise, _ref, successText, failText, spinner, promise, result;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            actionIsFunction = typeof action === 'function';
            actionIsPromise = typeof action.then === 'function';

            if (!(!actionIsFunction && !actionIsPromise)) {
              _context.next = 4;
              break;
            }

            throw new TypeError('Parameter `action` must be a Function or a Promise');

          case 4:
            _ref = _typeof(options) === 'object' ? options : {
              successText: undefined,
              failText: undefined
            }, successText = _ref.successText, failText = _ref.failText;
            spinner = ora(options).start();
            _context.prev = 6;
            promise = actionIsFunction ? action(spinner) : action;
            _context.next = 10;
            return promise;

          case 10:
            result = _context.sent;
            spinner.succeed(successText === undefined ? undefined : typeof successText === 'string' ? successText : successText(result));
            return _context.abrupt("return", result);

          case 15:
            _context.prev = 15;
            _context.t0 = _context["catch"](6);
            spinner.fail(failText === undefined ? undefined : typeof failText === 'string' ? failText : failText(_context.t0));
            throw _context.t0;

          case 19:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[6, 15]]);
  }));
  return _oraPromise.apply(this, arguments);
}
